## protobuf 3.6.1

=== debian/changelog ===
protobuf (3.6.1-4~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Pirate Praveen <praveen@debian.org>  Thu, 25 Oct 2018 11:27:54 +0530

protobuf (3.6.1-4) unstable; urgency=medium

  * Note that -dev package contains common proto files (closes: #842159).
  * Allow Java warnings on stderr during autopkgtest.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 23 Oct 2018 14:33:32 +0000

protobuf (3.6.1-3) unstable; urgency=medium

  * Generate all Java source files (closes: #911404).
  * Make package linux-only (closes: #837310).
  * Update Standards-Version to 4.2.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 20 Oct 2018 19:13:40 +0000

protobuf (3.6.1-2) unstable; urgency=medium

  * Fix linking with recent Google's C++ test framework.
  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 11 Oct 2018 15:15:45 +0000

protobuf (3.6.1-1) experimental; urgency=medium

  * New upstream release.
  * Builds with OpenJDK 10 (closes: #901518).
  * Library transition from libproto*16 to libproto*17 .
  * Extend Python 3.7 FTBFS fix.
  * Update Standards-Version to 4.1.5 .

  [ Michael Hudson-Doyle <michael.hudson@canonical.com> ]
  * Backport patch to fix FTBFS with Python 3.7 (closes: #902597).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 14 Aug 2018 18:22:07 +0000

protobuf (3.6.0.1-1) experimental; urgency=medium

  * New major upstream release.
  * Link with atomic on m68k, powerpcspe and sh4 architectures as well.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 11 Jun 2018 14:56:51 +0000

protobuf (3.6.0~rc2-2) experimental; urgency=medium

  * Build all Ruby files (closes: #900677).
  * Explicitly link with atomic on armel, mips, mipsel and powerpc
    architectures.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 03 Jun 2018 15:52:16 +0000

protobuf (3.6.0~rc2-1) experimental; urgency=medium

  * New major upstream release candidate version.
  * Make Ruby build dependencies architecture dependent.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 01 Jun 2018 13:00:39 +0000

protobuf (3.6.0~rc1-1) experimental; urgency=medium

  * New major upstream release candidate version.
  * Library transition from libproto*15 to libproto*16 .
  * Add ruby-google-protobuf package (closes: #855034).
  * Update patches.
  * Use packaged Google Test and Google Mock libraries.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 29 May 2018 22:00:11 +0000

protobuf (3.5.2-2) experimental; urgency=medium

  * Backport build fix for s390x architecture.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 27 Apr 2018 14:39:06 +0000

protobuf (3.5.2-1) experimental; urgency=medium

  * New upstream release (closes: #874498).
  * Library transition from libproto*10 to libproto*15 .
  * Make protobuf-compiler recommend libprotobuf-dev for basic upstream types
    (closes: #842158).
  * Take over maintainer responsibility.
  * Disable Vcs-* fields for now.
  * Update debhelper level to 11:
    - don't specify parallel to debhelper.
  * Update Standards-Version to 4.1.4 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 25 Apr 2018 21:29:01 +0000

=== debian/control ===
Source: protobuf
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
# Debian build system
 , debhelper (>= 11)
# C/C++
 , zlib1g-dev
 , libgmock-dev
 , libgtest-dev
# Python
 , dh-python
 , python-all:any
 , libpython-all-dev
 , python3-all:any
 , libpython3-all-dev
 , python-setuptools
 , python-six
 , python3-setuptools
 , python3-six
# Manpage generator
 , xmlto
# Tests
 , unzip
# Ruby
 , rake-compiler
 , gem2deb
Build-Depends-Indep:
# Java
 , ant
 , default-jdk
 , maven-repo-helper
Standards-Version: 4.2.1
Homepage: https://github.com/google/protobuf/
#Vcs-Browser: https://anonscm.debian.org/cgit/pkg-protobuf/pkg-protobuf.git
#Vcs-Git: https://anonscm.debian.org/git/pkg-protobuf/pkg-protobuf.git
X-Python-Version: >= 2.7
XS-Ruby-Versions: all

Package: ruby-google-protobuf
Architecture: linux-any
Multi-Arch: same
Section: ruby
X-DhRuby-Root: ruby
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: ruby-google-protobuf (<< 3.6.0~)
Replaces: ruby-google-protobuf (<< 3.6.0~)
Description: Protocol Buffers
 Protocol Buffers are Google's data interchange format.
 .
 This library contains the Ruby extension that implements Protocol Buffers
 functionality in Ruby.
 .
 The Ruby extension makes use of generated Ruby code that defines message and
 enum types in a Ruby DSL. You may write definitions in this DSL directly, but
 we recommend using protoc's Ruby generation support with .proto files. The
 build process in this directory only installs the extension; you need to
 install protoc as well to have Ruby code generation functionality.

Package: libprotobuf17
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: protocol buffers C++ library
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the runtime library needed for C++ applications.

Package: libprotobuf-lite17
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: protocol buffers C++ library (lite version)
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the runtime library needed for C++ applications whose
 message definitions have the "lite runtime" optimization setting.

Package: libprotobuf-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, zlib1g-dev,
 libprotobuf17 (= ${binary:Version}), libprotobuf-lite17 (= ${binary:Version})
Description: protocol buffers C++ library (development files) and proto files
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the development headers and static libraries needed for
 writing C++ applications. Includes well known proto type files.

Package: libprotoc17
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: protocol buffers compiler library
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the runtime library needed for the protocol buffer
 compiler.

Package: libprotoc-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libprotoc17 (= ${binary:Version}), libprotobuf-dev (= ${binary:Version})
Replaces: libprotobuf-dev (<< 2.1.0)
Breaks: libprotobuf-dev (<< 2.1.0)
Description: protocol buffers compiler library (development files)
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the development headers and static library needed for
 writing protobuf compilers.

Package: protobuf-compiler
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libprotoc17 (= ${binary:Version})
Recommends: libprotobuf-dev
Description: compiler for protocol buffer definition files
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the protocol buffer compiler that is used for
 translating from .proto files (containing the definitions) to the language
 binding for the supported languages.

Package: python-protobuf
Architecture: linux-any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: Python bindings for protocol buffers
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the Python bindings for the protocol buffers. You will
 need the protoc tool (in the protobuf-compiler package) to compile your
 definition to Python classes, and then the modules in this package will allow
 you to use those classes in your programs.

Package: python3-protobuf
Architecture: linux-any
Section: python
Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
XB-Python-Version: ${python3:Versions}
Description: Python 3 bindings for protocol buffers
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the Python 3 bindings for the protocol buffers. You will
 need the protoc tool (in the protobuf-compiler package) to compile your
 definition to Python classes, and then the modules in this package will allow
 you to use those classes in your programs.

Package: libprotobuf-java
Architecture: all
Depends: ${misc:Depends}
Section: java
Description: Java bindings for protocol buffers
 Protocol buffers are a flexible, efficient, automated mechanism for
 serializing structured data - similar to XML, but smaller, faster, and
 simpler. You define how you want your data to be structured once, then you can
 use special generated source code to easily write and read your structured
 data to and from a variety of data streams and using a variety of languages.
 You can even update your data structure without breaking deployed programs
 that are compiled against the "old" format.
 .
 Google uses Protocol Buffers for almost all of its internal RPC protocols and
 file formats.
 .
 This package contains the Java bindings for the protocol buffers. You will
 need the protoc tool (in the protobuf-compiler package) to compile your
 definition to Java classes, and then the modules in this package will allow
 you to use those classes in your programs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk
ifeq ($(origin CXX),default)
CXX := $(DEB_HOST_GNU_TYPE)-g++
endif

export DH_RUBY = --gem-install
export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-google-protobuf
export GEM2DEB_TEST_RUNNER = --check-dependencies

ifneq (,$(findstring $(DEB_BUILD_ARCH), armel m68k mips mipsel powerpc powerpcspe sh4))
export DEB_LDFLAGS_MAINT_APPEND  = -latomic
endif

%:
	dh $@ --with autoreconf,python2,python3

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
override_dh_auto_configure:
	# build for the native (i.e. build) architecture, as we need
	# the protoc compiler for the native arch.
	dh_auto_configure -- --host=$(DEB_BUILD_GNU_TYPE)

PYTHON_CROSS_VARS += PROTOC=$(CURDIR)/debian/run_protoc
PYTHON_CROSS_VARS += PYTHONPATH=/usr/lib/python$$pv/plat-$(DEB_HOST_MULTIARCH)
PYTHON_CROSS_VARS += _PYTHON_HOST_PLATFORM=$(DEB_HOST_ARCH_OS)-$(DEB_HOST_GNU_CPU)
PYTHON_CROSS_VARS += CC=$(CXX)
PYTHON_CROSS_VARS += CXX=$(CXX)
endif

override_dh_auto_build-arch:
## Chicken<->Egg problem: protobuf requires self-generated .pb.go files to
## be built. First we build it normally; then "generate_descriptor_proto.sh"
## generates .pb.go files and replaces 'em if they are different as well as
## invokes "make protoc" which re-builds "src/protoc" if required.
	dh_auto_build --arch
	bash -x ./generate_descriptor_proto.sh

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# save the native compiler
	cp -Rv src/.libs debian/native_protoc
	# clean everything but regenerated .pb.{cc,go} files
	$(MAKE) clean
	# cross build
	dh_auto_configure -- --with-protoc=$(CURDIR)/debian/run_protoc
	dh_auto_build --arch
endif

	# Generate the manpage.
	xmlto man debian/protoc.xml

	# Python and Python3 build.
	cp -rv python python3
	set -e; cd python && for pv in $(shell pyversions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py build --cpp_implementation; \
	done
	set -e; cd python3 && for pv in $(shell py3versions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py build --cpp_implementation; \
	done

	# Ruby build
	cd ruby && rake package genproto

override_dh_auto_build-indep:
	dh_auto_build --indep

	# Java build.
	ant -f debian/java-build.xml jar

override_dh_clean:
	$(RM) -rv gmock
	cd ruby && rake clobber
	dh_clean
	$(RM) -f config.h config.log config.status
	$(RM) -f *.pc
	$(RM) -f google-protobuf.gemspec
	$(RM) -f libtool stamp-h1
	find $(CURDIR) -name Makefile -delete

override_dh_auto_test-arch:
	dh_auto_test --arch

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Python test.
	set -e; \
	export LD_LIBRARY_PATH=$(CURDIR)/src/.libs; \
	cd python && for PYTHON in $(shell pyversions -r); do \
		$$PYTHON setup.py test --cpp_implementation; \
	done
    # Python3 test.
	set -e; \
	export LD_LIBRARY_PATH=$(CURDIR)/src/.libs; \
	cd python3 && for PYTHON in $(shell py3versions -r); do \
		$$PYTHON setup.py test --cpp_implementation; \
	done
endif

override_dh_auto_test-indep:
	:

override_dh_auto_clean-arch:
	dh_auto_clean --arch

	# Python clean.
	set -e; \
	cd python && for python in $(shell pyversions -r); do \
		$$python setup.py clean --all; \
	done
	rm -rf python/protobuf.egg-info
	# Python3 clean.
	rm -rf python3

override_dh_auto_clean-indep:
	dh_auto_clean --indep

	# Java clean.
	ant -f debian/java-build.xml clean || true
	mh_clean || true

override_dh_auto_install-arch:
	dh_auto_install --arch

	# Python install.
	set -e; \
	cd python && for pv in $(shell pyversions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py install --cpp_implementation \
			--install-layout=deb --no-compile \
			--root=$(CURDIR)/debian/python-protobuf; \
	done
	find $(CURDIR)/debian/python-protobuf -name 'protobuf-*-nspkg.pth' -delete

	# Python3 install.
	set -e; \
	cd python3 && for pv in $(shell py3versions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py install --cpp_implementation \
			--install-layout=deb --no-compile \
			--root=$(CURDIR)/debian/python3-protobuf; \
	done
	find $(CURDIR)/debian/python3-protobuf -name 'protobuf-*-nspkg.pth' -delete

	# Ruby install
	 sed 's|ext/|ruby/ext/|' $(CURDIR)/ruby/google-protobuf.gemspec \
		 >$(CURDIR)/google-protobuf.gemspec
	dh_auto_install -O--buildsystem=ruby -O--package=ruby-google-protobuf --destdir=debian/ruby-google-protobuf

override_dh_auto_install-indep:
	dh_auto_install --indep

	# Java install.
	mh_install

override_dh_install-arch:
	dh_install --arch

	# Convert doc dir to symlink for the -dev packages.
	rm -rf $(CURDIR)/debian/libprotobuf-dev/usr/share/doc/libprotobuf-dev
	ln -s libprotobuf17 $(CURDIR)/debian/libprotobuf-dev/usr/share/doc/libprotobuf-dev
	rm -rf $(CURDIR)/debian/libprotoc-dev/usr/share/doc/libprotoc-dev
	ln -s libprotoc17 $(CURDIR)/debian/libprotoc-dev/usr/share/doc/libprotoc-dev

	# Remove compiler headers from libprotobuf-dev.
	rm -rf $(CURDIR)/debian/libprotobuf-dev/usr/include/google/protobuf/compiler

## protobuf 3.6.1.3

=== cmake/CMakeLists.txt ===
# Minimum CMake required
cmake_minimum_required(VERSION 3.1.3)

if(protobuf_VERBOSE)
  message(STATUS "Protocol Buffers Configuring...")
endif()

# CMake policies
cmake_policy(SET CMP0022 NEW)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif()

# Project
project(protobuf C CXX)

# Add c++11 flags
if (CYGWIN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
else()
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

# Options
option(protobuf_BUILD_TESTS "Build tests" ON)
option(protobuf_BUILD_EXAMPLES "Build examples" OFF)
option(protobuf_BUILD_PROTOC_BINARIES "Build libprotoc and protoc compiler" ON)
if (BUILD_SHARED_LIBS)
  set(protobuf_BUILD_SHARED_LIBS_DEFAULT ON)
else (BUILD_SHARED_LIBS)
  set(protobuf_BUILD_SHARED_LIBS_DEFAULT OFF)
endif (BUILD_SHARED_LIBS)
option(protobuf_BUILD_SHARED_LIBS "Build Shared Libraries" ${protobuf_BUILD_SHARED_LIBS_DEFAULT})
include(CMakeDependentOption)
cmake_dependent_option(protobuf_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON
  "NOT protobuf_BUILD_SHARED_LIBS" OFF)
set(protobuf_WITH_ZLIB_DEFAULT ON)
option(protobuf_WITH_ZLIB "Build with zlib support" ${protobuf_WITH_ZLIB_DEFAULT})
set(protobuf_DEBUG_POSTFIX "d"
  CACHE STRING "Default debug postfix")
mark_as_advanced(protobuf_DEBUG_POSTFIX)
# User options
include(protobuf-options.cmake)

# Path to main configure script
set(protobuf_CONFIGURE_SCRIPT "../configure.ac")

# Parse configure script
set(protobuf_AC_INIT_REGEX
  "^AC_INIT\\(\\[([^]]+)\\],\\[([^]]+)\\],\\[([^]]+)\\],\\[([^]]+)\\]\\)$")
file(STRINGS "${protobuf_CONFIGURE_SCRIPT}" protobuf_AC_INIT_LINE
  LIMIT_COUNT 1 REGEX "^AC_INIT")
# Description
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\1"
    protobuf_DESCRIPTION    "${protobuf_AC_INIT_LINE}")
# Version
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\2"
    protobuf_VERSION_STRING "${protobuf_AC_INIT_LINE}")
# Contact
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\3"
    protobuf_CONTACT        "${protobuf_AC_INIT_LINE}")
# Parse version tweaks
set(protobuf_VERSION_REGEX "^([0-9]+)\\.([0-9]+)\\.([0-9]+)-?(.*)$")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\1"
  protobuf_VERSION_MAJOR "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\2"
  protobuf_VERSION_MINOR "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\3"
  protobuf_VERSION_PATCH "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\4"
  protobuf_VERSION_PRERELEASE "${protobuf_VERSION_STRING}")

# Package version
set(protobuf_VERSION
  "${protobuf_VERSION_MAJOR}.${protobuf_VERSION_MINOR}.${protobuf_VERSION_PATCH}")

if(protobuf_VERSION_PRERELEASE)
  set(protobuf_VERSION "${protobuf_VERSION}-${protobuf_VERSION_PRERELEASE}")
endif()

if(protobuf_VERBOSE)
  message(STATUS "Configuration script parsing status [")
  message(STATUS "  Description : ${protobuf_DESCRIPTION}")
  message(STATUS "  Version     : ${protobuf_VERSION} (${protobuf_VERSION_STRING})")
  message(STATUS "  Contact     : ${protobuf_CONTACT}")
  message(STATUS "]")
endif()

add_definitions(-DGOOGLE_PROTOBUF_CMAKE_BUILD)

find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
  add_definitions(-DHAVE_PTHREAD)
endif (CMAKE_USE_PTHREADS_INIT)

set(_protobuf_FIND_ZLIB)
if (protobuf_WITH_ZLIB)
  find_package(ZLIB)
  if (ZLIB_FOUND)
    set(HAVE_ZLIB 1)
    # FindZLIB module define ZLIB_INCLUDE_DIRS variable
    # Set ZLIB_INCLUDE_DIRECTORIES for compatible
    set(ZLIB_INCLUDE_DIRECTORIES ${ZLIB_INCLUDE_DIRECTORIES} ${ZLIB_INCLUDE_DIRS})
    # Using imported target if exists
    if (TARGET ZLIB::ZLIB)
      set(ZLIB_LIBRARIES ZLIB::ZLIB)
      set(_protobuf_FIND_ZLIB "if(NOT ZLIB_FOUND)\n  find_package(ZLIB)\nendif()")
    endif (TARGET ZLIB::ZLIB)
  else (ZLIB_FOUND)
    set(HAVE_ZLIB 0)
    # Explicitly set these to empty (override NOT_FOUND) so cmake doesn't
    # complain when we use them later.
    set(ZLIB_INCLUDE_DIRECTORIES)
    set(ZLIB_LIBRARIES)
  endif (ZLIB_FOUND)
endif (protobuf_WITH_ZLIB)

if (HAVE_ZLIB)
  add_definitions(-DHAVE_ZLIB)
endif (HAVE_ZLIB)

if (protobuf_BUILD_SHARED_LIBS)
  set(protobuf_SHARED_OR_STATIC "SHARED")
else (protobuf_BUILD_SHARED_LIBS)
  set(protobuf_SHARED_OR_STATIC "STATIC")
  # In case we are building static libraries, link also the runtime library statically
  # so that MSVCR*.DLL is not required at runtime.
  # https://msdn.microsoft.com/en-us/library/2kzt1wy3.aspx
  # This is achieved by replacing msvc option /MD with /MT and /MDd with /MTd
  # http://www.cmake.org/Wiki/CMake_FAQ#How_can_I_build_my_MSVC_application_with_a_static_runtime.3F
  if (MSVC AND protobuf_MSVC_STATIC_RUNTIME)
    foreach(flag_var
        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
  endif (MSVC AND protobuf_MSVC_STATIC_RUNTIME)
endif (protobuf_BUILD_SHARED_LIBS)

if (MSVC)
  # Build with multiple processes
  add_definitions(/MP)
  # MSVC warning suppressions
  add_definitions(
    /wd4018 # 'expression' : signed/unsigned mismatch
    /wd4065 # switch statement contains 'default' but no 'case' labels
    /wd4146 # unary minus operator applied to unsigned type, result still unsigned
    /wd4244 # 'conversion' conversion from 'type1' to 'type2', possible loss of data
    /wd4251 # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
    /wd4267 # 'var' : conversion from 'size_t' to 'type', possible loss of data
    /wd4305 # 'identifier' : truncation from 'type1' to 'type2'
    /wd4307 # 'operator' : integral constant overflow
    /wd4309 # 'conversion' : truncation of constant value
    /wd4334 # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
    /wd4355 # 'this' : used in base member initializer list
    /wd4506 # no definition for inline function 'function'
    /wd4800 # 'type' : forcing value to bool 'true' or 'false' (performance warning)
    /wd4996 # The compiler encountered a deprecated declaration.
  )
  # Allow big object
  add_definitions(/bigobj)
  string(REPLACE "/" "\\" PROTOBUF_SOURCE_WIN32_PATH ${protobuf_SOURCE_DIR})
  string(REPLACE "/" "\\" PROTOBUF_BINARY_WIN32_PATH ${protobuf_BINARY_DIR})
  string(REPLACE "." ","  protobuf_RC_FILEVERSION "${protobuf_VERSION}")
  configure_file(extract_includes.bat.in extract_includes.bat)

  # Suppress linker warnings about files with no symbols defined.
  set(CMAKE_STATIC_LINKER_FLAGS /ignore:4221)

  # Configure Resource Compiler
  enable_language(RC)
  # use English language (0x409) in resource compiler
  set(rc_flags "/l0x409")
  # fix rc.exe invocations because of usage of add_definitions()
  set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> ${rc_flags} <DEFINES> /fo<OBJECT> <SOURCE>")

  configure_file(version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
endif (MSVC)


get_filename_component(protobuf_source_dir ${protobuf_SOURCE_DIR} PATH)

include_directories(
  ${ZLIB_INCLUDE_DIRECTORIES}
  ${protobuf_BINARY_DIR}
  ${protobuf_source_dir}/src)

if (MSVC)
  # Add the "lib" prefix for generated .lib outputs.
  set(LIB_PREFIX lib)
else (MSVC)
  # When building with "make", "lib" prefix will be added automatically by
  # the build tool.
  set(LIB_PREFIX)
endif (MSVC)

if (protobuf_UNICODE)
  add_definitions(-DUNICODE -D_UNICODE)
endif (protobuf_UNICODE)

include(libprotobuf-lite.cmake)
include(libprotobuf.cmake)
if (protobuf_BUILD_PROTOC_BINARIES)
  include(libprotoc.cmake)
  include(protoc.cmake)
endif (protobuf_BUILD_PROTOC_BINARIES)

if (protobuf_BUILD_TESTS)
  include(tests.cmake)
endif (protobuf_BUILD_TESTS)

include(install.cmake)

if (protobuf_BUILD_EXAMPLES)
  include(examples.cmake)
endif (protobuf_BUILD_EXAMPLES)

if(protobuf_VERBOSE)
    message(STATUS "Protocol Buffers Configuring done")
endif()

=== debian/changelog ===
protobuf (3.6.1.3-2ubuntu5) focal; urgency=medium

  [ Rafael David Tinoco ]
  * Sponsoring ruby2.7 transitions

  [ Lucas Kanashiro ]
  * No-change rebuild for ruby2.7

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Wed, 26 Feb 2020 17:10:58 +0000

protobuf (3.6.1.3-2ubuntu4) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:44:52 +0100

protobuf (3.6.1.3-2ubuntu3) focal; urgency=medium

  * Use python2 in the autopkg test.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jan 2020 17:35:53 +0100

protobuf (3.6.1.3-2ubuntu2) focal; urgency=medium

  * Use python2 instead of python.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2020 17:04:47 +0100

protobuf (3.6.1.3-2ubuntu1) focal; urgency=medium

  * Build with -Wno-error=array-bounds to work around ftbfs on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:09:04 +0000

protobuf (3.6.1.3-2) unstable; urgency=medium

  * Prevent installation of non-working combination of libarcus3 and
    cura-engine (closes: #910964).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 16 Apr 2019 22:12:03 +0000

protobuf (3.6.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Mark libprotobuf-java Multi-Arch foreign.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 09 Dec 2018 12:45:11 +0000

protobuf (3.6.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Remove Python 3.7 patches as applied upstream.

  [ Michael Vogt <michael.vogt@ubuntu.com> ]
  * Remove explicit #!/usr/bin/python2.4 usage (closes: #600261).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 Dec 2018 16:13:58 +0000

protobuf (3.6.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 26 Nov 2018 23:23:31 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: protobuf
 Section: devel
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
 # Debian build system
  , debhelper (>= 11)
@@ -35,7 +36,7 @@
 Homepage: https://github.com/google/protobuf/
 #Vcs-Browser: https://anonscm.debian.org/cgit/pkg-protobuf/pkg-protobuf.git
 #Vcs-Git: https://anonscm.debian.org/git/pkg-protobuf/pkg-protobuf.git
-X-Python-Version: >= 2.7
+#X-Python-Version: >= 2.7
 XS-Ruby-Versions: all
 
 Package: ruby-google-protobuf
@@ -66,6 +67,7 @@
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libarcus3 (<< 3.3.0-2), cura-engine (<< 1:3.3.0-2.1+b1)
 Description: protocol buffers C++ library
  Protocol buffers are a flexible, efficient, automated mechanism for
  serializing structured data - similar to XML, but smaller, faster, and
@@ -233,6 +235,7 @@
 
 Package: libprotobuf-java
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Section: java
 Description: Java bindings for protocol buffers

=== debian/tests/control ===
Tests: simple
Depends: @, make, python2, pkg-config, zlib1g-dev, build-essential, default-jdk
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=uversionmangle=s/-?(beta)-?/~$1/;s/-?(alpha)-?/~$1/;s/-?(rc)-?/~rc/ \
https://github.com/google/protobuf/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|protobuf(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## protobuf 3.12.3

=== debian/changelog ===
protobuf (3.12.3-2~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Fri, 26 Mar 2021 13:53:26 -0400

protobuf (3.12.3-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Lower debhelper-compat to 11 for dwz compatibility

 -- Pirate Praveen <praveen@debian.org>  Thu, 30 Jul 2020 09:17:15 +0000

protobuf (3.12.3-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 08 Jul 2020 00:47:38 +0200

protobuf (3.12.3-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 06 Jun 2020 07:37:57 +0200

protobuf (3.12.2-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 27 May 2020 07:01:59 +0200

protobuf (3.12.0-1) experimental; urgency=medium

  * New major upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 17 May 2020 19:09:58 +0200

protobuf (3.12.0~rc1-1) experimental; urgency=medium

  * New major upstream release candidate version.
  * Update patches.
  * Library transition from libproto*22 to libproto*23 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 09 May 2020 18:45:17 +0000

protobuf (3.11.4-5) unstable; urgency=medium

  [ Olek Wojnar <olek@debian.org> ]
  * Allow building of protobuf-java-util (closes: #958444).
  * Add no_errorprone.patch since dependency not available in Debian.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 May 2020 17:43:12 +0000

protobuf (3.11.4-4) unstable; urgency=medium

  * Update Python version for self-tests (closes: #937327).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 10 Apr 2020 08:56:22 +0000

protobuf (3.11.4-3) unstable; urgency=medium

  * Python3ify examples.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 24 Mar 2020 18:20:00 +0000

protobuf (3.11.4-2) unstable; urgency=medium

  * Upload to Sid (closes: #934665).

  [ Jan Kriho <erbureth@gmail.com> ]
  * Break different protobuf-compiler versions in libprotobuf-dev
    (closes: #931836).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 21 Mar 2020 13:44:22 +0000

protobuf (3.11.4-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 16 Feb 2020 07:39:54 +0000

protobuf (3.11.3-1) experimental; urgency=medium

  * New upstream release.
  * Split protobuf-mode.el into a separate package (closes: #601600).
  * Update debhelper level to 12 .
  * Update Standards-Version to 4.5.0 .


 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 06 Feb 2020 17:37:12 +0000

protobuf (3.11.2-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 20 Dec 2019 08:03:17 +0000

protobuf (3.11.1-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 06 Dec 2019 16:38:45 +0000

protobuf (3.11.0-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from libproto*21 to libproto*22 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 28 Nov 2019 16:30:21 +0000

protobuf (3.10.1-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 31 Oct 2019 14:14:51 +0000

protobuf (3.10.0-1) experimental; urgency=medium

  * New major upstream release.
  * Remove extra commas from Build-Depends{,-Indep} (closes: #935499).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 08 Oct 2019 21:03:15 +0000

protobuf (3.10.0~rc1-2) experimental; urgency=medium

  * Still fix FTBFS with self-test of Python 2 bindings.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 12 Sep 2019 17:01:12 +0000

protobuf (3.10.0~rc1-1) experimental; urgency=medium

  * New major upstream release candidate version.
  * Library transition from libproto*20 to libproto*21 .
  * Remove python-protobuf package (closes: #937327).
  * Update Python packaging bits.
  * Update copyright file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 09 Sep 2019 15:42:05 +0000

protobuf (3.9.1-2) experimental; urgency=medium

  * Fix FTBFS with self-test of Python 2 bindings.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 09 Aug 2019 14:13:49 +0000

protobuf (3.9.1-1) experimental; urgency=medium

  * New major upstream release (closes: #933795).
  * Update Java build.
  * Make packages architecture: any again (closes: #923197).
  * Library transition from libproto*17 to libproto*20 .
  * Fix self-testing with Googletest <= 1.8.1 version.
  * Update Standards-Version to 4.4.0 .

  [ Laurence Parry <greenreaper@gmail.com> ]
  * Fix FTBFS on x32 due to versioned glibc symbols (closes: #931503).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 06 Aug 2019 16:36:47 +0000

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,20 @@
 Source: protobuf
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+# XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
 # Debian build system
- , debhelper (>= 11)
+   debhelper-compat (= 11)
+ , dh-elpa
 # C/C++
  , zlib1g-dev
  , libgmock-dev
  , libgtest-dev
 # Python
  , dh-python
- , python-all:any
- , libpython-all-dev
  , python3-all:any
  , libpython3-all-dev
- , python-setuptools
- , python-six
  , python3-setuptools
  , python3-six
 # Manpage generator
@@ -29,10 +26,12 @@
  , gem2deb
 Build-Depends-Indep:
 # Java
- , ant
+   ant
  , default-jdk
  , maven-repo-helper
-Standards-Version: 4.2.1
+ , libguava-java
+ , libgoogle-gson-java
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/protobuf/
 #Vcs-Browser: https://anonscm.debian.org/cgit/pkg-protobuf/pkg-protobuf.git
 #Vcs-Git: https://anonscm.debian.org/git/pkg-protobuf/pkg-protobuf.git
@@ -40,7 +39,7 @@
 XS-Ruby-Versions: all
 
 Package: ruby-google-protobuf
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: ruby
 X-DhRuby-Root: ruby
@@ -62,8 +61,8 @@
  build process in this directory only installs the extension; you need to
  install protoc as well to have Ruby code generation functionality.
 
-Package: libprotobuf17
-Architecture: linux-any
+Package: libprotobuf23
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -82,8 +81,8 @@
  .
  This package contains the runtime library needed for C++ applications.
 
-Package: libprotobuf-lite17
-Architecture: linux-any
+Package: libprotobuf-lite23
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -103,11 +102,12 @@
  message definitions have the "lite runtime" optimization setting.
 
 Package: libprotobuf-dev
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends}, zlib1g-dev,
- libprotobuf17 (= ${binary:Version}), libprotobuf-lite17 (= ${binary:Version})
+ libprotobuf23 (= ${binary:Version}), libprotobuf-lite23 (= ${binary:Version})
+Breaks: protobuf-compiler (<< ${binary:Version}), protobuf-compiler (>> ${binary:Version})
 Description: protocol buffers C++ library (development files) and proto files
  Protocol buffers are a flexible, efficient, automated mechanism for
  serializing structured data - similar to XML, but smaller, faster, and
@@ -123,8 +123,8 @@
  This package contains the development headers and static libraries needed for
  writing C++ applications. Includes well known proto type files.
 
-Package: libprotoc17
-Architecture: linux-any
+Package: libprotoc23
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -144,11 +144,11 @@
  compiler.
 
 Package: libprotoc-dev
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
- libprotoc17 (= ${binary:Version}), libprotobuf-dev (= ${binary:Version})
+ libprotoc23 (= ${binary:Version}), libprotobuf-dev (= ${binary:Version})
 Replaces: libprotobuf-dev (<< 2.1.0)
 Breaks: libprotobuf-dev (<< 2.1.0)
 Description: protocol buffers compiler library (development files)
@@ -167,10 +167,11 @@
  writing protobuf compilers.
 
 Package: protobuf-compiler
-Architecture: linux-any
+Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, libprotoc17 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libprotoc23 (= ${binary:Version})
 Recommends: libprotobuf-dev
+Suggests: protobuf-mode-el
 Description: compiler for protocol buffer definition files
  Protocol buffers are a flexible, efficient, automated mechanism for
  serializing structured data - similar to XML, but smaller, faster, and
@@ -187,35 +188,10 @@
  translating from .proto files (containing the definitions) to the language
  binding for the supported languages.
 
-Package: python-protobuf
-Architecture: linux-any
-Section: python
-Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
-Provides: ${python:Provides}
-XB-Python-Version: ${python:Versions}
-Description: Python bindings for protocol buffers
- Protocol buffers are a flexible, efficient, automated mechanism for
- serializing structured data - similar to XML, but smaller, faster, and
- simpler. You define how you want your data to be structured once, then you can
- use special generated source code to easily write and read your structured
- data to and from a variety of data streams and using a variety of languages.
- You can even update your data structure without breaking deployed programs
- that are compiled against the "old" format.
- .
- Google uses Protocol Buffers for almost all of its internal RPC protocols and
- file formats.
- .
- This package contains the Python bindings for the protocol buffers. You will
- need the protoc tool (in the protobuf-compiler package) to compile your
- definition to Python classes, and then the modules in this package will allow
- you to use those classes in your programs.
-
 Package: python3-protobuf
-Architecture: linux-any
+Architecture: any
 Section: python
 Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
-Provides: ${python3:Provides}
-XB-Python-Version: ${python3:Versions}
 Description: Python 3 bindings for protocol buffers
  Protocol buffers are a flexible, efficient, automated mechanism for
  serializing structured data - similar to XML, but smaller, faster, and
@@ -254,3 +230,22 @@
  need the protoc tool (in the protobuf-compiler package) to compile your
  definition to Java classes, and then the modules in this package will allow
  you to use those classes in your programs.
+
+Package: elpa-protobuf-mode
+Architecture: all
+Depends: ${misc:Depends}, ${elpa:Depends}
+Section: editors
+Description: Emacs addon for editing protocol buffers
+ Protocol buffers are a flexible, efficient, automated mechanism for
+ serializing structured data - similar to XML, but smaller, faster, and
+ simpler. You define how you want your data to be structured once, then you can
+ use special generated source code to easily write and read your structured
+ data to and from a variety of data streams and using a variety of languages.
+ You can even update your data structure without breaking deployed programs
+ that are compiled against the "old" format.
+ .
+ Google uses Protocol Buffers for almost all of its internal RPC protocols and
+ file formats.
+ .
+ This package provides an emacs major mode for editing files in protocol
+ buffers format. It features syntax highlighting and auto-indentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
ifeq ($(origin CXX),default)
CXX := $(DEB_HOST_GNU_TYPE)-g++
endif

export DH_RUBY = --gem-install
export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-google-protobuf
export GEM2DEB_TEST_RUNNER = --check-dependencies

ifneq (,$(findstring $(DEB_BUILD_ARCH), armel m68k mips mipsel powerpc powerpcspe sh4))
export DEB_LDFLAGS_MAINT_APPEND  = -latomic
endif

SONAME=23

%:
	dh $@ --with autoreconf,elpa,python3

override_dh_strip:
	dh_strip --no-automatic-dbgsym

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
override_dh_auto_configure:
	# build for the native (i.e. build) architecture, as we need
	# the protoc compiler for the native arch.
	dh_auto_configure -- --host=$(DEB_BUILD_GNU_TYPE)

PYTHON_CROSS_VARS += PROTOC=$(CURDIR)/debian/run_protoc
PYTHON_CROSS_VARS += PYTHONPATH=/usr/lib/python$$pv/plat-$(DEB_HOST_MULTIARCH)
PYTHON_CROSS_VARS += _PYTHON_HOST_PLATFORM=$(DEB_HOST_ARCH_OS)-$(DEB_HOST_GNU_CPU)
PYTHON_CROSS_VARS += CC=$(CXX)
PYTHON_CROSS_VARS += CXX=$(CXX)
endif

override_dh_auto_build-arch:
## Chicken<->Egg problem: protobuf requires self-generated .pb.go files to
## be built. First we build it normally; then "generate_descriptor_proto.sh"
## generates .pb.go files and replaces 'em if they are different as well as
## invokes "make protoc" which re-builds "src/protoc" if required.
	dh_auto_build --arch
	bash -x ./generate_descriptor_proto.sh

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# save the native compiler
	cp -Rv src/.libs debian/native_protoc
	# clean everything but regenerated .pb.{cc,go} files
	$(MAKE) clean
	# cross build
	dh_auto_configure -- --with-protoc=$(CURDIR)/debian/run_protoc
	dh_auto_build --arch
endif

	# Generate the manpage
	xmlto man debian/protoc.xml

	# Python3 build
	cp -rv python python3
	set -e; cd python3 && for pv in $(shell py3versions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py build --cpp_implementation; \
	done

	# Ruby build
	cd ruby && rake package genproto

override_dh_auto_build-indep:
	dh_auto_build --indep

	# Java build
	ant -f debian/java-build.xml jar jar-util

override_dh_clean:
	$(RM) -rv gmock
	cd ruby && rake clobber
	dh_clean
	$(RM) config.h config.log config.status
	$(RM) *.pc
	$(RM) google-protobuf.gemspec
	$(RM) libtool stamp-h1
	$(RM) ruby/tests/basic_test_pb.rb \
		ruby/tests/basic_test_proto2_pb.rb \
		ruby/tests/generated_code_pb.rb \
		ruby/tests/generated_code_proto2_pb.rb \
		ruby/tests/google/protobuf/wrappers_pb.rb \
		ruby/tests/test_import_pb.rb \
		ruby/tests/test_import_proto2_pb.rb \
		ruby/tests/test_ruby_package_pb.rb \
		ruby/tests/test_ruby_package_proto2_pb.rb
	find $(CURDIR) -name Makefile -delete

override_dh_auto_test-arch:
	dh_auto_test --arch

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
    # Python3 test
	set -e; \
	export LD_LIBRARY_PATH=$(CURDIR)/src/.libs; \
	cd python3 && for PYTHON in $(shell py3versions -r); do \
		$$PYTHON setup.py test --cpp_implementation; \
	done
endif

override_dh_auto_test-indep:
	:

override_dh_auto_clean-arch:
	dh_auto_clean --arch

	# Python3 clean
	$(RM) -r $(CURDIR)/python3

override_dh_auto_clean-indep:
	dh_auto_clean --indep

	# Java clean
	ant -f debian/java-build.xml clean || true
	mh_clean || true

override_dh_auto_install-arch:
	dh_auto_install --arch

	# Python3 install
	set -e; \
	cd python3 && for pv in $(shell py3versions -vr); do \
		$(PYTHON_CROSS_VARS) python$$pv setup.py install --cpp_implementation \
			--install-layout=deb --no-compile \
			--root=$(CURDIR)/debian/python3-protobuf; \
	done
	find $(CURDIR)/debian/python3-protobuf -name 'protobuf-*-nspkg.pth' -delete

	# Ruby install
	 sed 's|ext/|ruby/ext/|' $(CURDIR)/ruby/google-protobuf.gemspec \
		 >$(CURDIR)/google-protobuf.gemspec
	dh_auto_install -O--buildsystem=ruby -O--package=ruby-google-protobuf --destdir=$(CURDIR)/debian/ruby-google-protobuf
	find $(CURDIR)/debian/ruby-google-protobuf/usr/lib/ \
		-name well_known_types.rb -exec chmod a+x {} \;

override_dh_auto_install-indep:
	dh_auto_install --indep
	find $(CURDIR)/debian/tmp/usr/lib/ \
		-name '*.la' -delete

	# Java install
	mh_install

override_dh_install-arch:
	dh_install --arch

	# Convert doc dir to symlink for the -dev packages
	$(RM) -r $(CURDIR)/debian/libprotobuf-dev/usr/share/doc/libprotobuf-dev
	ln -s libprotobuf$(SONAME) $(CURDIR)/debian/libprotobuf-dev/usr/share/doc/libprotobuf-dev
	$(RM) -r $(CURDIR)/debian/libprotoc-dev/usr/share/doc/libprotoc-dev
	ln -s libprotoc$(SONAME) $(CURDIR)/debian/libprotoc-dev/usr/share/doc/libprotoc-dev

	# Remove compiler headers from libprotobuf-dev
	$(RM) -r $(CURDIR)/debian/libprotobuf-dev/usr/include/google/protobuf/compiler

override_dh_installdocs-arch:
	dh_installdocs --arch
	# Fix permission
	chmod a-x $(CURDIR)/debian/protobuf-compiler/usr/share/doc/protobuf-compiler/examples/README.md
	# Remove extra .gitignore
	rm $(CURDIR)/debian/protobuf-compiler/usr/share/doc/protobuf-compiler/examples/.gitignore

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_installdocs -Xprotobuf-mode.el  # in protobuf-mode-el
